Skip to content

Misinterpretation of malicious XML input

moderate severity Published Aug 3, 2021 in xmldom/xmldom • Updated Aug 23, 2021

Package

npm xmldom (npm)

Affected versions

<= 0.6.0

Patched versions

None

Description

Impact

xmldom versions 0.6.0 and older do not correctly escape special characters when serializing elements removed from their ancestor. This may lead to unexpected syntactic changes during XML processing in some downstream applications.

Patches

Update to one of the fixed versions of @xmldom/xmldom (^0.5.1 || ^0.6.1 || >=0.7.0). Users of xmldom should switch to @xmldom/xmldom to not be affected by this vulnerability.

See issue #271 for the status of publishing xmldom to npm or join #270 for Q&A/discussion until it's resolved.

Workarounds

Downstream applications can validate the input and reject the maliciously crafted documents.

References

Similar to this one reported on the Go standard library:

For more information

If you have any questions or comments about this advisory:

  • Open an issue in xmldom/xmldom
  • Email us: send an email to all addresses that are shown by npm owner ls @xmldom/xmldom

References

@karfau karfau published the maintainer security advisory Jul 27, 2021

CVE ID

CVE-2021-32796

CVSS Score

6.5 Moderate
CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N